/* -*- buffer-read-only: t -*- vi: set ro:
#line 382
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 382
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfrom.h"
#include "prog.h"
#include "builtin.h"

#line 17 "bi_dns.m4"
/* This file is part of mailfrom filter.             -*- c -*-
#line 17
   Copyright (C) 2006 Sergey Poznyakoff
#line 17

#line 17
   This program is free software; you can redistribute it and/or modify
#line 17
   it under the terms of the GNU General Public License as published by
#line 17
   the Free Software Foundation; either version 2, or (at your option)
#line 17
   any later version.
#line 17

#line 17
   This program is distributed in the hope that it will be useful,
#line 17
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 17
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 17
   GNU General Public License for more details.
#line 17

#line 17
   You should have received a copy of the GNU General Public License
#line 17
   along with this program; if not, write to the Free Software
#line 17
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#line 17
   MA 02110-1301 USA */

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

void
#line 24
bi_hostname(eval_environ_t env)
#line 24 "bi_dns.m4"
{
#line 24
	
#line 24
char * string = (char *) get_arg(env, 0);
#line 24
        
#line 24
        adjust_stack(env, 1);
#line 24

#line 24
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 24
		prog_trace(env, "hostname %s",string);;
#line 24

{
	char *hbuf;
	if (resolve_ipstr(string, &hbuf) != mf_success) 
		pushs(env, string);
	else {
		pushs(env, hbuf);
		free(hbuf);
	}
}
}

void
#line 36
bi_resolve(eval_environ_t env)
#line 36 "bi_dns.m4"
{
#line 36
	
#line 36
char * string = (char *) get_arg(env, 0);
#line 36
        
#line 36
        adjust_stack(env, 1);
#line 36

#line 36
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 36
		prog_trace(env, "resolve %s",string);;
#line 36

{
	char *ipstr;
	if (resolve_hostname(string, &ipstr) != mf_success)
		pushs(env, "0");
	else {
		pushs(env, ipstr);
		free(ipstr);
	}
}
}

void
#line 48
bi_hasmx(eval_environ_t env)
#line 48 "bi_dns.m4"
{
#line 48
	
#line 48
char * string = (char *) get_arg(env, 0);
#line 48
        
#line 48
        adjust_stack(env, 1);
#line 48

#line 48
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 48
		prog_trace(env, "hasmx %s",string);;
#line 48

{
	mxbuf_t mxbuf;
	mf_status mxstat;

	mxstat = getmx(string, mxbuf);
	
	if (mxstat != mf_success) {
		if (env_catch(env, mxstat) == 0)
			return;
	} else
		freemx(mxbuf);

	do {
#line 61
push(env, (STKVAL) (mxstat == mf_success));
#line 61
return;
#line 61
} while (0);
}
}

void
#line 65
bi_getmx(eval_environ_t env)
#line 65 "bi_dns.m4"
{
#line 65
	
#line 65
char * domain = (char *) get_arg(env, 1);
#line 65
        long  resolve = (long ) get_arg(env, 0);
#line 65
        
#line 65
        adjust_stack(env, 2);
#line 65

#line 65
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 65
		prog_trace(env, "getmx %s %lu",domain, resolve);;
#line 65

{
	mxbuf_t mxbuf;
	mf_status mxstat;
	int i;

	if (resolve)
		mxstat = getmxip(domain, mxbuf);
	else
		mxstat = getmx(domain, mxbuf);
		if (!(mxstat == mf_success || mxstat == mf_not_found))
#line 77
			do {
#line 77
		if (env_catch(env, mxstat) == 0)
#line 77
			return ;
#line 77
		else
#line 77
			runtime_error(env,
#line 77
				                                                  "getmx: " "Cannot get MX records for %s",domain);
#line 77
	} while (0) 
#line 77
;
#line 77
;
	if (mxstat == mf_not_found)
		do {pushs(env, "");
#line 79
return;
#line 79
} while (0);
	else {
		int i;
		size_t ns;
		char *p;
		
		size_t size;
#line 85
char *s = heap_max_tempspace(env, &size)
#line 85
;
		
		for (i = 0, ns = 0, p = s; i < MAXMXCOUNT && mxbuf[i]; i++) {
			size_t len = strlen(mxbuf[i]);
			if (ns + len + 1 > size)
				break;
			if (i > 0)
				*p++ = ' ';
			memcpy(p, mxbuf[i], len);
			p += len;
			ns += len + 1;
		}
		*p = 0;
		freemx(mxbuf);
		
#line 99
do {
#line 99
push(env, (STKVAL) (heap_fix_tempspace(env, ns)));
#line 99
return;
#line 99
} while (0);
	}
}
}

static int
resolve_host(const char *string, unsigned long *ip)
{
	int rc;
	struct in_addr addr;
	char *ipstr;

	if (inet_aton(string, &addr)) {
		*ip = addr.s_addr;
		return 0;
	}
	
	if (resolve_hostname(string, &ipstr) != mf_success)
		return 1;

	rc = inet_aton(ipstr, &addr);
	free(ipstr);
	if (rc == 0) {
		mu_error("INTERNAL ERROR at %s:%lu: resolve_hostname returned "
			 "invalid IP address: %s",
			 __FILE__, __FILE__, ipstr);
		return 1;
	}
	*ip = addr.s_addr;
	return 0;
}

void
#line 131
bi_ismx(eval_environ_t env)
#line 131 "bi_dns.m4"
{
#line 131
	
#line 131
char * domain = (char *) get_arg(env, 1);
#line 131
        char * ipstr = (char *) get_arg(env, 0);
#line 131
        
#line 131
        adjust_stack(env, 2);
#line 131

#line 131
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 131
		prog_trace(env, "ismx %s %s",domain, ipstr);;
#line 131

{
	mxbuf_t mxbuf;
	mf_status mxstat;
	unsigned long ip;
	int rc = 0;
	
		if (!(resolve_host(ipstr, &ip) == 0))
			do {
#line 139
		if (env_catch(env, mf_resolve) == 0)
#line 139
			return ;
#line 139
		else
#line 139
			runtime_error(env,
#line 139
				                                                  "ismx: " "cannot resolve host name %s",ipstr);
#line 139
	} while (0) 
#line 139
;
#line 139
;
	
	mxstat = getmx(domain, mxbuf);
	
	if (mxstat != mf_success) {
		if (env_catch(env, mxstat) == 0)
			return;
	} else {
		int i;

		for (i = 0; i < MAXMXCOUNT && mxbuf[i]; i++) {
			unsigned long n;
			
			if (!resolve_host(mxbuf[i], &n) && n == ip) {
				rc = 1;
				break;
			}
		}
		freemx(mxbuf);
	}
	do {
#line 159
push(env, (STKVAL) (rc));
#line 159
return;
#line 159
} while (0);
}
}

void
#line 163
bi_relayed(eval_environ_t env)
#line 163 "bi_dns.m4"
{
#line 163
	
#line 163
char * s = (char *) get_arg(env, 0);
#line 163
        
#line 163
        adjust_stack(env, 1);
#line 163

#line 163
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 163
		prog_trace(env, "relayed %s",s);;
#line 163

{
	do {
#line 165
push(env, (STKVAL) (relayed_domain_p(s)));
#line 165
return;
#line 165
} while (0);
}
}

void
#line 169
bi_listens(eval_environ_t env)
#line 169 "bi_dns.m4"
{
#line 169
	
#line 169
char * s = (char *) get_arg(env, 0);
#line 169
        
#line 169
        adjust_stack(env, 1);
#line 169

#line 169
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 169
		prog_trace(env, "listens %s",s);;
#line 169

{
	do {
#line 171
push(env, (STKVAL) (listens_on (s, 25) == mf_success));
#line 171
return;
#line 171
} while (0);
}
}

void
#line 175
bi_match_cidr(eval_environ_t env)
#line 175 "bi_dns.m4"
{
#line 175
	
#line 175
char * ipstr = (char *) get_arg(env, 1);
#line 175
        char * cidrstr = (char *) get_arg(env, 0);
#line 175
        
#line 175
        adjust_stack(env, 2);
#line 175

#line 175
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 175
		prog_trace(env, "match_cidr %s %s",ipstr, cidrstr);;
#line 175

{
	char *p;
	struct in_addr addr, cidr;
	char netbuf[16], *netstr;
	unsigned long netmask;
	int result = 0;
	const struct locus *locus = env_get_locus(env);
	
	do {
			if (!(inet_aton(ipstr, &addr)))
#line 188
			do {
#line 188
		if (env_catch(env, mf_invip) == 0)
#line 188
			return ;
#line 188
		else
#line 188
			runtime_error(env,
#line 188
				                                                  "match_cidr: " "invalid IP address (%s)",ipstr);
#line 188
	} while (0) 
#line 188
;
#line 188
;
		p = strchr(cidrstr, '/');
		if (!p) {
			netstr = cidrstr;
			netmask = 0xfffffffful;
		} else {
			size_t len = p - cidrstr;
			unsigned long n;
			
				if (!(len < sizeof netbuf))
#line 199
			do {
#line 199
		if (env_catch(env, mf_invcidr) == 0)
#line 199
			return ;
#line 199
		else
#line 199
			runtime_error(env,
#line 199
				                                                  "match_cidr: " "invalid CIDR (%s)",cidrstr);
#line 199
	} while (0) 
#line 199
;
#line 199
;
			memcpy(netbuf, cidrstr, len);
			netbuf[len] = 0;
			netstr = netbuf;
			n = strtoul(p + 1, &p, 10);
				if (!(*p == 0 && n <= 32))
			do {
#line 205
		if (env_catch(env, mf_invcidr) == 0)
#line 205
			return ;
#line 205
		else
#line 205
			runtime_error(env,
#line 205
				                                                  "match_cidr: " "invalid CIDR (netmask of %s)",cidrstr);
#line 205
	} while (0) 
#line 205
;
#line 205
;
			n = 32 - n;
			if (n == 32)
				netmask = 0;
			else
				netmask = (0xfffffffful >> n) << n;
		}
			if (!(inet_aton(netstr, &cidr)))
#line 214
			do {
#line 214
		if (env_catch(env, mf_invcidr) == 0)
#line 214
			return ;
#line 214
		else
#line 214
			runtime_error(env,
#line 214
				                                                  "match_cidr: " "invalid CIDR (network part of %s)",cidrstr);
#line 214
	} while (0) 
#line 214
;
#line 214
;

		addr.s_addr = ntohl(addr.s_addr);
		cidr.s_addr = ntohl(cidr.s_addr);
		debug5(100, "%s:%lu: addr=%lx net=%lx mask=%lx" ,
		       locus->file, locus->line,
		       addr.s_addr, cidr.s_addr, netmask);
		result = (addr.s_addr & netmask) == cidr.s_addr;
	} while (0);
	do {
#line 223
push(env, (STKVAL) (result));
#line 223
return;
#line 223
} while (0);
}
}

void
#line 227
bi_domainpart(eval_environ_t env)
#line 227 "bi_dns.m4"
{
#line 227
	
#line 227
char * str = (char *) get_arg(env, 0);
#line 227
        
#line 227
        adjust_stack(env, 1);
#line 227

#line 227
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 227
		prog_trace(env, "domainpart %s",str);;
#line 227

{
	char *p = strchr(str, '@');
	do {
#line 230
push(env, (STKVAL) (p ? p+1 : str));
#line 230
return;
#line 230
} while (0);
}
}

void
#line 234
bi_localpart(eval_environ_t env)
#line 234 "bi_dns.m4"
{
#line 234
	
#line 234
char * str = (char *) get_arg(env, 0);
#line 234
        
#line 234
        adjust_stack(env, 1);
#line 234

#line 234
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 234
		prog_trace(env, "localpart %s",str);;
#line 234

{
	char *p = strchr(str, '@');

	if (p) {
		size_t size = p - str;
		char *string_space = heap_reserve(env, size + 1);
		memcpy(string_space, str, size);
		string_space[size] = 0;
		do {
#line 243
push(env, (STKVAL) (string_space));
#line 243
return;
#line 243
} while (0);
	} else
		do {pushs(env, str);
#line 245
return;
#line 245
} while (0);
}
}


#line 249
void
#line 249
dns_init_builtin()
#line 249
{
#line 249
	#line 24 "bi_dns.m4"
va_builtin_install_ex("hostname", bi_hostname, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 36 "bi_dns.m4"
va_builtin_install_ex("resolve", bi_resolve, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 48 "bi_dns.m4"
va_builtin_install_ex("hasmx", bi_hasmx, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 65 "bi_dns.m4"
va_builtin_install_ex("getmx", bi_getmx, 0, 0, dtype_string,  2, 1,  dtype_string, dtype_number);
#line 131 "bi_dns.m4"
va_builtin_install_ex("ismx", bi_ismx, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_string);
#line 163 "bi_dns.m4"
va_builtin_install_ex("relayed", bi_relayed, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 169 "bi_dns.m4"
va_builtin_install_ex("listens", bi_listens, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 175 "bi_dns.m4"
va_builtin_install_ex("match_cidr", bi_match_cidr, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_string);
#line 227 "bi_dns.m4"
va_builtin_install_ex("domainpart", bi_domainpart, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 234 "bi_dns.m4"
va_builtin_install_ex("localpart", bi_localpart, 0, 0, dtype_string,  1, 0,  dtype_string);

#line 249 "bi_dns.m4"
		
#line 249
}
#line 0

#line 0

